function [Q_inv,Freq_out] = Q_inv_FFT(e_zz_vary,s_zz_vary,Time_vary,zero_padding)


% % Quality control
% figure(20)
% subplot(211), plot(Time_vary,e_zz_vary,'*')
% subplot(212), plot(Time_vary,s_zz_vary,'*')


tstep = Time_vary(2:end)-Time_vary(1:end-1);
% figure(30)
% plot(Time_vary(1:end-1),tstep,'*')
len_tstep = length(tstep);
% ---------------

dt = 1*(Time_vary(2)-Time_vary(1));
time_tot = Time_vary(end);

Time = 0:dt:time_tot;

e_zz = interp1(Time_vary,e_zz_vary,Time);
s_zz = interp1(Time_vary,s_zz_vary,Time);

% figure(1)
% set(gcf,'Units','Normalized','Position',[0.05 0.05 0.85 0.85])
% subplot(321), plot(Time,e_zz), ylabel('e_{zz}'), xlabel('time')
% subplot(322), plot(Time,s_zz), ylabel('s_{zz}'), xlabel('time')

e_zz_o = [0 e_zz(1:end-1)];
et_zz = (e_zz-e_zz_o)/dt; 
s_zz_o = [0 s_zz(1:end-1)];
st_zz = (s_zz-s_zz_o)/dt;

% %figure(2)
% set(gcf,'Units','Normalized','Position',[0.05 0.05 0.85 0.85])
% subplot(323), plot(Time,et_zz), ylabel('et_{zz}'), xlabel('time')
% subplot(324), plot(Time,st_zz), ylabel('st_{zz}'), xlabel('time')


Time_ext = [0:dt:zero_padding*Time(end)];
Len = length(Time_ext)-length(Time);

et_zz_ext           = [et_zz zeros(1,Len)];
st_zz_ext           = [st_zz zeros(1,Len)];

time = Time_ext;
fft_length = -1;

% strain
velocity = et_zz_ext;
dt = time(2)-time(1);   
FFTLength = size(velocity,2);
if nargin == 3
    if fft_length == 1
        FFTLength = pow2(nextpow2(size(velocity,2)));
    elseif fft_length == -1
        FFTLength = pow2(nextpow2(size(velocity,2))-1);
    end
end
spectrum = fft(velocity',FFTLength)';
df = 1/(dt*FFTLength);
fNyquist = 1/2/dt;
if ~mod(FFTLength,2)
    spectrum = spectrum(:,2:end/2+1);
else
    spectrum = spectrum(:,2:(end+1)/2);
end
frequency_fft = df:df:fNyquist;
Freq_out = frequency_fft;
et_zz_w = spectrum;

% stress
velocity = st_zz_ext;
dt = time(2)-time(1);   
FFTLength = size(velocity,2);
if nargin == 3
    if fft_length == 1
        FFTLength = pow2(nextpow2(size(velocity,2)));
    elseif fft_length == -1
        FFTLength = pow2(nextpow2(size(velocity,2))-1);
    end
end
spectrum = fft(velocity',FFTLength)';
df = 1/(dt*FFTLength);
fNyquist = 1/2/dt;
if ~mod(FFTLength,2)
    spectrum = spectrum(:,2:end/2+1);
else
    spectrum = spectrum(:,2:(end+1)/2);
end
frequency_fft = df:df:fNyquist;
Freq_out = frequency_fft;
st_zz_w = spectrum;



% derived Q
C33         = st_zz_w./et_zz_w;    
Q_inv       = 1./(-real(C33)./imag(C33));

% 
% figure(3)
% %subplot('position',[left bottom width height]); box on; 
% plot(Freq_out,1./Q_C33,'-r','linewidth',1); hold on
% xlim([6e-1 1e3]); %ylim([0 0.08])
% xlabel('Frequency (Hz)','fontname','times','fontsize',12)
% ylabel('1/\itQ','fontname','times','fontsize',12)
% hold on;
% for prop_f_multiplicator = -3:0.5:5
%     plot(Freq_out,Freq_out/(10^prop_f_multiplicator),'color',[0.5 0.5 0.5]);
% end
% for prop_invf_multiplicator = -3:0.5:5
%     plot(Freq_out,1./Freq_out/(10^prop_invf_multiplicator),'color',[0.5 0.5 0.5]);
% end
% for prop_invsqrtf_multiplicator = -3:0.5:5
%     plot(Freq_out,1./sqrt(Freq_out)/(10^prop_invsqrtf_multiplicator),'color',[0.7 0.3 0.0]);
% end
% %ylim([10^-4,10^1]);
% xlim([10^0,10^3]);
% set(gca,'xscale','log')
% set(gca,'yscale','log')
% %print -dtiff -r600 Figure

