# creates the sets for all surfaces after reading the file that defines the bottom left three surfaces (row1column1, r1c2, r2c1)

# before running this file
# 1. open the cae file with the final geometry (hence, it must have been created but the surfaces are probably wrongly assigned)
# 2. run the following command in the Abaqus command line window: session.journalOptions.setValues(replayGeometry=COORDINATE, recoverGeometry=COORDINATE)
# 3. delete and redefine the three surfaces: Surf-r1c1, Surf-r1c2, Surf-r2c1 (these are the lower left one, its right neighbour, its top neighbour) 
# 4. go to the updated .jnl file and copy the three corresponding commands to the file called surface_construction_manualextraction.py (delete former content in that file)

readfile = open('surface_construction_manualextraction.py', 'r')
lines = [line.rstrip('\n') for line in readfile]
readfile.close()

face1_lowerindex = []
face1_upperindex = []
face2_lowerindex = []
face2_upperindex = []
face3_lowerindex = []
face3_upperindex = []
append_to_face1 = 1
append_to_face2 = 0
append_to_face3 = 0

for line_iter in range(0,size(lines)):
    current_line = lines[line_iter]
    if current_line.find('face1') >= 0:
        append_to_face1 = 1
        append_to_face2 = 0
        append_to_face3 = 0
    elif current_line.find('face2') >= 0:
        append_to_face1 = 0
        append_to_face2 = 1
        append_to_face3 = 0
    elif current_line.find('face3') >= 0:
        append_to_face1 = 0
        append_to_face2 = 0
        append_to_face3 = 1
    else:
        numbers_start = current_line.find('.elements[')
        numbers_separ = current_line.find(':')
        numbers_end = current_line.find(']',numbers_start)
        if numbers_start >= 0:
            lower_number = current_line[10+numbers_start:numbers_separ]
            upper_number = current_line[numbers_separ+1:numbers_end]
            if append_to_face1 == 1:
                face1_lowerindex.append(int(lower_number))
                face1_upperindex.append(int(upper_number))
            elif append_to_face2 == 1:
                face2_lowerindex.append(int(lower_number))
                face2_upperindex.append(int(upper_number))
            elif append_to_face3 == 1:
                face3_lowerindex.append(int(lower_number))
                face3_upperindex.append(int(upper_number))

shift_numbering_x_per_c = face1_lowerindex[size(face1_lowerindex)/3]-face1_lowerindex[0]
shift_numbering_y_per_r = face1_lowerindex[size(face1_lowerindex)/3*2]-face1_lowerindex[0]
face1_lowerindex_origin = face1_lowerindex[0:size(face1_lowerindex)/3]
face1_upperindex_origin = face1_upperindex[0:size(face1_upperindex)/3]
face2_lowerindex_origin = face2_lowerindex[0:size(face2_lowerindex)/3]
face2_upperindex_origin = face2_upperindex[0:size(face2_upperindex)/3]
face3_lowerindex_origin = face3_lowerindex[0:size(face3_lowerindex)/3]
face3_upperindex_origin = face3_upperindex[0:size(face3_upperindex)/3]

writefile = open('surface_construction_all.py', 'w')
for row_iter in range(0,no_holes_ver):
    for column_iter in range(0,no_holes_hor):
        write_row = 1 + row_iter
        write_column = 1 + column_iter
        shift = row_iter*shift_numbering_y_per_r + column_iter*shift_numbering_x_per_c
        writefile.write("mdb.models['ellipsesquirt'].rootAssembly.Surface(face1Elements=\n")
        for number_iter in range(0,size(face1_lowerindex_origin)-1):
            writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face1_lowerindex_origin[number_iter]+shift) + ":" + str(face1_upperindex_origin[number_iter]+shift) + "]+ ")
        writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face1_lowerindex_origin[-1]+shift) + ":" + str(face1_upperindex_origin[-1]+shift) + "]\n")
        writefile.write("    , face2Elements=\n")
        for number_iter in range(0,size(face2_lowerindex_origin)-1):
            writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face2_lowerindex_origin[number_iter]+shift) + ":" + str(face2_upperindex_origin[number_iter]+shift) + "]+ ")
        writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face2_lowerindex_origin[-1]+shift) + ":" + str(face2_upperindex_origin[-1]+shift) + "]\n")
        if face3_lowerindex:
            writefile.write("    , face3Elements=\n")
            for number_iter in range(0,size(face3_lowerindex_origin)-1):
                writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face3_lowerindex_origin[number_iter]+shift) + ":" + str(face3_upperindex_origin[number_iter]+shift) + "]+ ")
            writefile.write("    mdb.models['ellipsesquirt'].rootAssembly.instances['Inst-Full'].elements[" + str(face3_lowerindex_origin[-1]+shift) + ":" + str(face3_upperindex_origin[-1]+shift) + "]\n")
        writefile.write("    , name='Surf-r" + str(write_row) + "c" + str(write_column) + "')\n")
writefile.close
